﻿
init python:
    class nvl_phone_class:
        def __init__(self):
            self.elapsed = 0
            self.typing = False
            self.times = []
            self.locked = False
            self.person = None
        def tick(self):
            pass
            self.elapsed += 1
            if len(self.times):
                
                if self.elapsed >= self.times[0]:
                    self.elapsed = 0
                    if self.typing:
                        self.typing = False
                    else:
                        self.typing = True
                    self.times.pop(0)
            else:
                self.typing = False
                self.locked = False
                return 1
        def start(self, person, times = [10, 10, 10, 10]):
            self.person = person
            self.times = times
            self.elapsed = 0
            self.typing = True
            self.locked = True

default nvl_phone = nvl_phone_class()

screen nvl(dialogue, items=None):
    style_prefix "nvlphone"
    add "#0008"
    frame:
        xysize(600,900) padding(0,0) background "#222" align .5,.5

        frame: # Top bar
            ysize 100 xfill True background "#111" yalign 0.0
            button:
                align 0.0,.5 background "#222" xysize 40,40
                text "⬅"
                action Hide("chat_app_chat")
            text "Ririn"
        viewport:
            draggable True scrollbars None yinitial 1.0 align .5,.5
            xfill False
            # yfill False
            yalign 1.0
            ysize 690 yoffset -100
            vbox: # Chat
                xsize 560 yalign 1.0
                spacing 10
                for n, d in enumerate(dialogue):

                    if d.who == "Ayame":
                        hbox:
                            xalign 1.0
                            frame:
                                background Frame(im.Flip("phone/chat_frame.png", True), 8, 8, 16, 8)
                                padding 8,8,16,8 xmaximum 420 yminimum 64
                                text d.what:
                                    color "#000"

                            if not dialogue[n-1].who == d.who or n == 0:
                                add "phone {}".format(d.who)
                            else:
                                null width 64

                    else:
                        hbox:
                            xalign 0.0
                            if not dialogue[n-1].who == d.who or n == 0:
                                add "phone {}".format(d.who)
                            else:
                                null width 64
                            frame:
                                background Frame("phone/chat_frame.png", 16, 8, 8, 8)
                                padding 16,8,8,8 xmaximum 420 yminimum 64
                                text d.what:
                                    color "#000"
        text d.what: # Ignore
            id d.what_id
            yoffset -1000

        vbox: # Input
            yalign 1.0 spacing -12
            if nvl_phone.typing:
                hbox:
                    xalign 0.0 xoffset 10
                    text str(nvl_phone.person) size 15
                    text "is typing..." size 15

            frame:
                background "#111" margin 10,10
                padding 8,8,16,8 xfill True yminimum 90
                text "Type something..." color "#aaa" xalign 0.0


        frame: # Choice
            align .5,.5 background "#222" padding 0,0
            vbox:
                spacing 4
                for i in items:
                    button:
                        text i.caption
                        action i.action
                        background "#111" yminimum 64 xsize 540 padding 10,10

    if nvl_phone.locked:
        button: # While typing this button will keep the screen locked, comment out if you don't want it to be locked
            background None
            action NullAction()
        timer .1 repeat True action Function(nvl_phone.tick)

style nvlphone_text:
    size 20
    align (.5,.5)

style nvlphone:
    align (.5,.5)

define config.nvl_list_length = 40
define config.nvl_adv_transition = None
define config.adv_nvl_transition = None
define aya = Character("Ayame", kind=nvl)
define rin = Character("Ririn", kind=nvl)
image phone Ayame = "phone/img2.png"
image phone Ririn = "phone/img1.png"
define menu = nvl_menu


label nvl_phone_example:
    $ preferences.transitions = 0 #disable transitions when entering nvl mode
    # it's not an elegant solution but we have to use this one till I find a better way
    # don't forget to set it back to 2 before exiting this mode

    rin "hey{nw}" # {nw} will automatically advance the conversation
    $ nvl_phone.start("Ririn") # who is typing
    pause
    rin "what are you wearing?{nw}"
    $ nvl_phone.start("Ririn", [10, 20, 35]) # You can give it a list of typing pauses in tenth of seconds in this case it shows [typing for 1 sec, nothing foe 2 sec, typing for 3.5 sec]
    pause
    rin "something naughty I hope :3"
    # if you don't add a `typing...` the game advances with user input instead and {nw} is not necessary 
    rin "or nothing at all{nw}"

    menu: # You can have normal dialogue but letting the player click each one gives the illusion of replying
        "stop it":
            aya "stop it{nw}"
    menu:
        ":(":
            aya ":({nw}"
    rin "alright, alright"
    rin "just kidding"

    rin "are you ready for tomorrow? hiking, camping, marshmallows"
    rin "and boys :3"

    menu:
        "I'm not sure...":
            aya "I'm not sure...{nw}"
    menu:
        "Boys can be rowdy and loud on trips like this.":
            aya "Boys can be rowdy and loud on trips like this.{nw}"
    rin "that's not an answer I can accept.."
    rin "do you want me to come over and tackle you to submission again?"
    
    menu:
        "no, I'll get ready":
            aya "no, I'll get ready{nw}"
        "I'll call you":
            aya "I'll call you{nw}"
            rin "Wearing my shoes."
            menu:
                "Alright, alright, fine, I'll come.":
                    aya "Alright, alright, fine, I'll come.{nw}"
        "I said no":
            aya "I said no.{nw}"
            rin "Don't tell me..."
            rin "Have you found a BF?"
            aya "Noooooooooooo!"
            rin "Do you want one?"
            aya "..."
            rin "Your coming or I'm giving your number to Kenji."
            aya "You're terrible..."
            rin "Thats a yes, kind of... Rin wins again."
    rin "ok see you tomorrow!"
    rin "bye"
    menu:
        "bye":
            aya "bye"
    $ preferences.transitions = 2 
    pause







